/**
 * Copyright (c) 2024 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "rpg/world/map.h"
#include "assert/assert.h"

#define TEST_MAP_WIDTH MAP_WIDTH_MAX
#define TEST_MAP_HEIGHT MAP_HEIGHT_MAX
#define TEST_MAP_LAYERS 1

void testMapInit(map_t *map) {
  mapInit(map, TEST_MAP_WIDTH, TEST_MAP_HEIGHT, TEST_MAP_LAYERS);

  entity_t *player = mapEntityAdd(map);
  entityInit(player, ENTITY_TYPE_PLAYER, map);
  entityPositionSet(player, 5, 5);

  entity_t *npc = mapEntityAdd(map);
  entityInit(npc, ENTITY_TYPE_NPC, map);
  entityPositionSet(npc, 10, 10);

  trigger_t *trigger = mapTriggerAdd(map);
  triggerInit(trigger, TRIGGER_TYPE_NULL, 15, 15, 1, 1);

  tile_t tiles[TEST_MAP_WIDTH * TEST_MAP_HEIGHT];
  for(uint32_t i = 0; i < TEST_MAP_WIDTH * TEST_MAP_HEIGHT; i++) {
    tiles[i] = TILE_ID_GRASS;
  }

  tiles[10] = TILE_ID_WATER;
  tiles[11] = TILE_ID_WATER;
  tiles[12] = TILE_ID_WATER;
  tiles[13] = TILE_ID_WATER;
  tiles[14] = TILE_ID_WATER;

  tiles[26] = TILE_ID_WATER;
  tiles[27] = TILE_ID_WATER;
  tiles[28] = TILE_ID_WATER;
  tiles[29] = TILE_ID_WATER;

  tiles[41] = TILE_ID_WATER;
  tiles[42] = TILE_ID_WATER;
  tiles[43] = TILE_ID_WATER;
  tiles[44] = TILE_ID_WATER;
  tiles[45] = TILE_ID_WATER;

  mapTilesSet(map, tiles, 0);
}